<?php defined('SYSPATH') OR die('No direct access allowed.');

class LiveException extends Exception {};

class SynergyLivestatus {
	static private $__instance = NULL;
	static public function getInstance() {
		if(!self::$__instance) {
			self::$__instance = new self("/opt/monitor/var/rw/live");
		}
		return self::$__instance;
	}

	private $__socket_handler = NULL;
	private $__socket_path = "";
	private $__debug = false;
	private function __clone() {}

	private function __readSocket($len) {
		$offset = 0;
		$result = "";
		while($offset < $len) {
			if (FALSE === ($data = @socket_read($this->__socket_handler, $len - $offset)) ) {
				return FALSE;
			}
			$read = strlen($data);
			$offset += $read;
			$result .= $data;

			if (0 === $read) {
				break;
			}
		}
		return $result;
	}

	public function connect() {
		//
	}

	public function close() {
		@socket_close($this->__socket_handler);
		$this->__socket_handler = NULL;
	}

	private function __query(LiveQuery $query, $decode) {
		try {
			if (FALSE === socket_write($this->__socket_handler, $query->compile() . "KeepAlive: on\nOutputFormat:json\nResponseHeader: fixed16\n\n")) {
				 throw new LiveException("Couldn`t write to socket.". sprintf(" Socket error: [%s] %s", $errorcode = socket_last_error($this->__socket_handler), socket_strerror($errorcode)));
			}
		} catch(Exception $e) {
			throw new LiveException("Socket write error: ".$e->getMessage());
		}

		try {
			$read = $this->__readSocket(16);
		} catch(Exception $e) {
			throw new LiveException("Socket read error: ".$e->getMessage());
		}

		if (FALSE === $read) {
			throw new LiveException("Problem while reading from socket: ".socket_strerror(socket_last_error($this->__socket_handler)) );
		}

		$status = substr($read, 0, 3);

		$len = intval(trim(substr($read, 4, 11)));

		try {
			$read = $this->__readSocket($len);
		} catch(Exception $e) {
			throw new LiveException("Socket read error: ".$e->getMessage());
		}

		if (FALSE === $read) {
			throw new LiveException("Problem while reading from socket: ".socket_strerror(socket_last_error($this->__socket_handler)) );
		}

		if ($status !== "200") {
			throw new LiveException('Problem while reading from socket: '.$read);
		}

		if (socket_last_error($this->__socket_handler) == 104) {
			throw new LiveException("Problem while reading from socket: ".socket_strerror(socket_last_error($this->__socket_handler)) );
		}

		if (!$decode) {
			return $read;
		}

		$obj = json_decode($read);

		if (NULL === $obj) {
			throw new LiveException("The response has an invalid format");
		}

		return $obj;
	}

	public function query(LiveQuery $query, $decode = true) {
		$exit = false;
		$counter = 0;
		$res;
		while(!$exit) {
			try {
				$res = $this->__query($query, $decode);
				$exit = true;
			} catch(LiveException $e) {
				$counter ++;
				if ($counter >= 50) { // 5sec timeout TODO: in param with usleep param
					throw new LiveException("Monitor seems not running");
				}
				// TODO: write to syslog message
				usleep(100);
			}
		}
		return $res;
	}

	private function __construct($path) {
		$this->__socket_path = $path;

		if (!file_exists($this->__socket_path)) {
			throw new LiveException(sprintf("%s no such socket file.", $this->__socket_path));
		}

		if (!function_exists("socket_create")) {
			throw new LiveException("The PHP function socket_create is not available. Maybe the sockets module is missing in your PHP installation.");
		}

		$this->__socket_handler = socket_create(AF_UNIX, SOCK_STREAM, 0);

		if (FALSE === $this->__socket_handler) {
			throw new LiveException("Could not create livestatus socket connection." . sprintf(" Socket error: [%s] %s", $errorcode = socket_last_error($this->__socket_handler), socket_strerror($errorcode)));
		}

		if (FALSE === socket_connect($this->__socket_handler, $this->__socket_path)) {
			throw new LiveException("Unable to connect to livestatus socket." . sprintf(" Socket error: [%s] %s", $errorcode = socket_last_error($this->__socket_handler), socket_strerror($errorcode)));	
		}
	}
}
