var updateTimer; // Holds setTimeout function that iterates update function.

// Checks if the synergy service is running, if not attempts to start it and if that fails gives a message to contact administrator.
var serviceCheck = function() {
    base_url = "/monitor/index.php";
    $.ajax({
        type: "GET",
        dataType: "text",
        url: base_url + "/synergy/service_check",
        success: function(data) {
            if (data != 0) {
                $("#notification-board").html("The BSM service isn't running. Attempting to start service.").attr("data-status", "CRITICAL");
                $.ajax({
                    type: "GET",
                    dataType: "text",
                    url: base_url + "/synergy/service_start",
                    success: function(data) {
                        if (data != 0) {
                            // Synergy service failed to start.
                            $("#notification-board").html("The BSM service failed to start. Contact your administrator.").attr("data-status", "CRITICAL");
                            // Clear the error message after 10 seconds.
                            setTimeout(function() { $("#notification-board").html("").attr("data-status", null); }, 10000);
                        } else if (data == 0) {
                            // Service has indeed been started.
                            $("#notification-board").html("The BSM service has started").attr("data-status", "OK");
                            // Clear the success message after 5 seconds.
                            setTimeout(function() { $("#notification-board").html("").attr("data-status", null); }, 5000);
                        }
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        console.log(jqXHR);
                        console.log(textStatus);
                        console.log(errorThrown);
                    }
                });
            }
        },
        error: function(jqXHR, textStatus, errorThrown) {
            console.log(jqXHR);
            console.log(textStatus);
            console.log(errorThrown);
        }
    });
};
// Check if the synergy service is running.
serviceCheck();

(function($) {
    var reg_o = /^\[([^0-9]\w*)\]/,
        reg_v = /^(\w+)/;
    
    function parse(str, val) {
        var split_val, ret_val;
        if (str.length === 0) return val;
        if (reg_o.test(str)) return (ret_val = {})[(split_val = str.split(reg_o))[1]] = parse(split_val[2], val),ret_val;
        if (reg_v.test(str)) return (ret_val = {})[(split_val = str.split(reg_v))[1]] = parse(split_val[2], val),ret_val;
    };

    $.ns = function(namespace, start) {
        if (!namespace) return;
        var parts = namespace.split('.');
        if (!parts.length) return;
        var head = start || window;
        var part = parts[0];
        for (var i = 0; i < parts.length; i++,part = parts[i]) {
            if (typeof(head[part]) === 'undefined') {
                head = (head[part] = {});
            } else {
                head = head[part];
            }
        }
        return head;
    };
    $.ns_tree = function(namespace, start) {
        if (!namespace) return;
        var parts = namespace.split('.');
        if (!parts.length) return;
        var head = start || window;
        var part = parts[0];
        for (var i = 0; i < parts.length; i++,part = parts[i]) {
            if (typeof(head[part]) === 'undefined') {
                return false;
            } else {
                head = head[part];
            }
        }
        return head;
    },
    $.recontext = function(context, callback) {
        return function() {
            return callback.apply(context, arguments);
        };
    };
    $.objectKeys = function(obj) {
        if (!(obj instanceof Object)) return;
        var res = [];
        for (var indx in obj) {
            if (!obj.hasOwnProperty(indx)) continue;
            res.push(indx);
        }
        return res;
    };
    $.filterJson = function(list, rule, strict) {
        strict = strict || true;
        var item, rule_val, item_result, result = {};
        for (var indx in list) {
            if (list.hasOwnProperty(indx)) {
                item_result = true;
                item = list[indx];
                for (var rule_name in rule) {
                    if (rule.hasOwnProperty(rule_name)) {
                        if (!item.hasOwnProperty(rule_name)) {
                            item_result = false;
                            break;
                        }
                        rule_val = rule[rule_name];
                        if ($.isArray(rule_val)) {
                            if(-1 === $.inArray(item[rule_name], rule_val) ) {
                                item_result = false;
                                break;
                            }
                            continue;
                        }
                        if (typeof(rule_val) === "string") {
                            if (rule_val[0] === "~") {
                                if (-1 === item[rule_name].search(new RegExp(rule_val.substring(1), 'i'))) {
                                    item_result = false;
                                    break;
                                }
                                continue;
                            }
                        }
                        if (strict) {
                            if (rule_val !== item[rule_name]) {
                                item_result = false;
                                break;
                            }
                            continue;
                        }
                        if (rule_val != item[rule_name]) {
                            item_result = false;
                            break;
                        }
                    }
                }
                if (!item_result) {
                    continue;
                }
                result[indx] = list[indx];
            }
        }
        return result;
    };
    var __compare = {
        string: function(a, b) {
            if (a.value < b.value) return 1;
            if (a.value === b.value) return 0;
            return -1;
        },
        number: function(a, b) {
            return a.value - b.value;
        }
    };
    $.eachSort = function(data, key, func) {
        if(!key) return;
        var sort_type;
        var map = [];
        if ($.isEmpty(data)) return;
        $.each(data, function(k, v) {
            if (typeof(v[key]) === "undefined") return;
            if (typeof(sort_type) === "undefined") {
                sort_type = typeof(v[key]);
            } else {
                if (sort_type !== typeof(v[key])) {
                    console.error("error value type for sorting");
                    return;
                }
            }
            map.push({key: k, value: v[key]});
        });
        if (typeof(__compare[sort_type]) !== "function") {
            console.error("no compare function for "+sort_type+" type");
            return;
        }
        //map.sort(__compare[sort_type]);
        $.each(map, function(i, key) {
            func.call(data[key.key], key.key, data[key.key]);
        });
        return data;
    },
    $.unparam = function(str) {
        if(str.length === 0) { return {}; }
        var parts = str.split('&'),
            key_value,
            result = {};
        $.each(parts, function() {
            var key = decodeURIComponent((key_value = this.split('='))[0]),
                val = decodeURIComponent(key_value[1]);
            $.extend(true, result, parse(key, val));
        });
        return result;
    };
    $.tmpl = function(str, obj) {
        for(var i in obj) {
            if(!obj.hasOwnProperty(i)) continue;
            while(str.match("[[" + i + "]]")) {
                str = str.replace("[[" + i + "]]", obj[i]);
            }
        }
        return str;
    };
    $.isEmpty = function(ob) {
        if (!(ob instanceof Object)) return true;
        for(var i in ob) if(ob.hasOwnProperty(i)) return false;
        return true;
    };
    $.insertValues = function(parent, values) {
        $.each(values, function(k, v) {
            $(k, parent).html(v);
        });
    };
    $.fn.multiflexselect = function(opts) {
        var g_opts = { delimer: "&" };
        opts = $.extend(g_opts, opts);
        var cls = core.classes.Multiselect;
        $.each(this, function() { 
           new cls(this, opts); 
        });
    };
    $.fn.materialized = function(is_checked) {
        var cls = core.classes.Materialize;
        $.each(this, function() {
            new cls(this, is_checked);
        });
    };
    $.cloneObject = function(src) {
        if (!(src instanceof Object)) return src;
        var new_level = {}, name, val;
        for (key in src) {
            if(!src.hasOwnProperty(key)) continue;
            val = src[key];
            if(val instanceof Object) {
                new_level[key] = $.cloneObject(val);
            } else {
                new_level[key] = val;
            }
        }
        return new_level;
    };
    $.inObjectList = function(list, key, value) {
        if ($.isEmpty(list)) return false;
        for (var i in list) {
            if (!list.hasOwnProperty(i)) continue;
            if (typeof(list[i][key]) === "undefined") {
                console.error("no "+key+" key in object", list[i]);
                return false;
            }
            if (list[i][key] === value) return true;
        }
        return false;
    };
    $.timeDiffFormat = function(time, start_point) {
        if(!time) return "N/A";
        start_point = start_point || (new Date()).getTime();
        var diff_minutes = parseInt((start_point - time) / (1000 * 60)), minutes_part, hours_part;
        if(diff_minutes <= 0) return "less then a minute ago";
        var diff_hours = parseInt(diff_minutes / 60);
        if(diff_hours <= 0) return diff_minutes + "m ago";
        minutes_part = parseInt(diff_minutes % 60);
        minutes_part = minutes_part ? (" " + minutes_part + "m") : "";
        var diff_days = parseInt(diff_hours / 24);
        if(diff_days <= 0) return diff_hours + "h" + minutes_part + " ago";
        hours_part = parseInt(diff_hours % 24);
        hours_part = hours_part ? (" " + hours_part + "h") : "";
        return diff_days + "d" + hours_part + minutes_part + " ago";
    };
    var __pre_zero = function(num) {
        if (parseInt(num) >= 10) return num;
        return "0" + num;
    }
    $.timeFormat = function(date) {
        if (parseInt(date) === 0) {
            return "N/A";
        }
        if(!(date instanceof Date)) {
            if (parseInt(date)) {
                date = new Date(date);
            } else {
                date = new Date();
            }
        }
        var y = date.getFullYear(), 
            m = __pre_zero(date.getMonth() + 1), 
            d = __pre_zero(date.getDate()), 
            h = __pre_zero(date.getHours()), 
            min = __pre_zero(date.getMinutes()), 
            s = __pre_zero(date.getSeconds());
        return  y+"-"+m+"-"+d+" "+h+":"+min+":"+s; 
    };
    $.ns("core.events");
    $.ns("core.classes");
    core.__path =  "/";
})(_njq);

// Multiselect Plugin
(function($) {
    var wrapper = $("<span class=\"multiselect-wrapper\"><span class=\"step-wrapper\"></span></span>"),
    Multiselect = function(node, opts) {
        this.node = $(node);
        this.wrapper = wrapper.clone();
        this.step_wrapper = $(".step-wrapper", this.wrapper);
        this.node.after(this.wrapper);
        this.delimer = opts.delimer;
        this.data = {};
        this.id = this.node.attr("id");
        this.name = this.node.attr("name");
        this.res = null;
        this.result = {};
        this.current_input = null;
        this.current_hidden = null;
        this.depth = 0;
        this.step = 0;
        this.init();
    };
    Multiselect.prototype = {
        init: function() {
            var that = this;
            var init_val;
            $("option", this.node).each(function() {
                if ($(this).attr("data-populate") === "1") {
                    init_val = $(this).val();
                }
                var line = $(this).val().split(that.delimer), i, head = that.data;
                that.depth = line.length;
                for (i = 0; i < line.length; i ++) {
                    if(!head[line[i]]) {
                        head[line[i]] = {};
                    }
                    head = head[line[i]];
                }
            });
            this.res = $(t = $.tmpl("<input name=\"[[n]]\" id=\"[[i]]\" type=\"hidden\"/>", {
                n: this.name,
                i: this.id
            })).appendTo(this.wrapper);
            this.node.detach();
            this.show_step(0, false);
            if (init_val) {
                var sv = init_val.split("&");
                for (var i = 0; i < sv.length; i++) {
                    this.step_selected(sv[i], false);
                }
            } else {
                this.res.find("input[type=hidden]").val(null);
            }
            
        },
       show_step: function(step, focus) {
            focus = focus === false ? false : true;
            if(step == this.depth) { return this.set_result(); }
            this.step = step;
            var new_select = "<select name=\"\" id=\""+this.id+"_step"+step+"\">", input;
            var head = this.data;
            for(var i = 0; i < this.step; i++) {
                head = head[this.result[i]];
            }
            for(var name in head) {
                new_select += "<option value=\""+name+"\">"+name+"</option>";
            }
            new_select += "</select>";
            this.wrapper.append(new_select);
            $("select", this.wrapper).flexselect();
            this.current_input = input = $("#" + this.id + "_step" + step + "_flexselect", this.wrapper);
            this.current_hidden = $("#" + this.id + "_step" + step, this.wrapper);
            this.current_input.addClass("ignore");
            this.current_hidden.addClass("ignore");
            input.val(null);
            if(focus) {
                input.trigger("focus")
            }
            input.bind("item-selected", {w: this}, function(e) {
                e.data.w.step_selected($(this).val());
            });
        },
        step_selected: function(value, focus) {
            focus = focus === false ? false : true;
            this.result[this.step] = value;
            this.render_result();
            this.current_input.detach();
            this.current_hidden.detach();
            // $(".flexselect_dropdown").remove();
            this.show_step(this.step+1, focus);
        },
        render_result: function() {
            var indx, cur_selected;
            this.step_wrapper.empty();
            for(indx in this.result) {
                cur_selected = $("<span class=\"step-value\" data-step=\""+indx+"\">"+this.result[indx]+"</span>");
                this.step_wrapper.append(cur_selected);
                cur_selected.bind("click", {w: this}, function(e) {
                    e.data.w.step_back($(this).attr("data-step"));
                });
            }
        },
        set_result: function() {
            var r = [], t;
            for(var indx in this.result) {
                r.push(this.result[indx]);
            }
            this.res.val(r.join("&"));
        },
        step_back: function(step) {
            step = parseInt(step);
            this.step = step;
            var new_result = {}, new_value;
            for(var i = 0; i < step; i++) { new_result[i] = this.result[i]; }
            this.res.val(null);
            $("input", this.wrapper).not(this.res).remove();
            this.result = new_result;
            this.render_result();
            this.show_step(this.step);
        }
    };
    $.ns("core.classes").Multiselect = Multiselect;
})(_njq);

// Materialize Plugin
(function($) {
    var Materialize = function(node) {
        this.node = $(node);
        var init_val = $("#materialized", this.node).val();
        this.is_checked = init_val.length !== 0;
        $("label[for=\"Materialized\"]", this.node).before("<input type=\"checkbox\" class=\"is-use\"></input>").bind("click", {w: this}, function(e) {
            e.data.w.change();
        })
        this.node.delegate(".is-use", "change", $.recontext(this, this.change));
        this.update(true);
        if (init_val) {
            $("#materialized_flexselect", this.node).val(init_val);
            setTimeout(function() { $("#materialized").val(init_val); }, 100);
        }
    };
    Materialize.prototype = {
        change: function() {
            this.is_checked = ! this.is_checked;
            this.update();
        },
        update: function(just_init) {
            if(this.is_checked) {
                this.node.removeClass("field-disabled");
                $("input[type=\"checkbox\"]", this.node).prop("checked", true);
                var fs = $(".flexselect", this.node).attr("disabled", null);
                if (!just_init) {
                    fs.select();
                }
            } else {
                $("input[type=\"checkbox\"]", this.node).prop("checked", false);
                this.node.addClass("field-disabled");
                $(".flexselect", this.node).attr("disabled", "disabled").clear_flexselect();
            }
        }
    };
    $.ns("core.classes").Materialize = Materialize;
})(_njq);

// DataWrapper
(function($) {
    var syn_data;
    var __is_changed = false;
    var changed = function() {
        $("#sync-button").addClass("active");
        $("#undo-button").addClass("active");
        $("#notification-board").html("You have unsaved configuration changes. Please press SAVE to activate them.").attr("data-status", "WARNING");
        __is_changed = true;
    };
    var unchange = function() {
        __is_changed = false;
    };
    var initial_data, list_data;
    var deleted_list = [];
    var updated_list = [];
    var _toList = function(res, url, d) {
        var url = url || "", result = res || {}, indx, new_url;
        d = d || syn_data.items;
        for(indx in d) {
            if(!d.hasOwnProperty(indx)) continue;
            new_url = url + (url.length ? "/" : "") + indx;
            result[new_url] = d[indx];
            result[new_url]["url"] = new_url;
            if(typeof(d[indx]["items"]) === "undefined") continue;
            _toList(result, new_url, d[indx]["items"]);
        }
        return result;
    },
    each_sub_element = function(p, func) {
        var r = new RegExp(("^" + p).replace(/\//g, "\\/"));
        $.each(list_data, function(k, v) {
            if (r.test(k)) {
                func.call(this, k, v);
            }
        });
    };
    var _getMaterializedList = function(data, path) {
        if (data.name) {
            path = (path || "") + "/" + data.name;
        } else {
            path = "";
        }
        res = [];
        if (data.materialized) {
            var v = data.materialized.host + "&" + data.name;
            if ($.inArray(v, res) === -1) {
                res.push({value: v, path: path});
            }
        }
        if (data.items) {
            $.each(data.items, function(k,v) {
                res = res.concat(_getMaterializedList(v, path));
            });
        }
        return res;
    };
    var _getDiff = function() {
        var cur = _getMaterializedList(syn_data), add = []
            init = _getMaterializedList(initial_data), del = [];
        $.each(cur, function(k, v) {
            if (!$.inObjectList(init, "value", v.value)) {
                add.push({service: v.value.split("&"), path: v.path.replace(/^\/+/, "")});
            }
        });
        $.each(init, function(k, v) {
            if (!$.inObjectList(cur, "value", v.value)) {
                del.push({service: v.value.split("&"), path: v.path.replace(/^\/+/, "")});
            }
        });
        return {"add": JSON.stringify(add), "del": JSON.stringify(del)};
    };
    var _toSaveObj = function(data) {
        data = data || syn_data;
        if (typeof(data["type"]) === "undefined") {
            console.error("Error ogject in queue. Ignore.");
            return false;
        }
        
        var res = {};
        res["name"] = data["name"] || "no-name";
        res["intent"] = data["type"] + "." + data["rule"] + "(";
        if (data["materialized"]) {
            res["materialized"] = data["materialized"];
        }
        var args = []; $.each(data.args || [], function(i) {
            if(actions[data["rule"]].params[i].type == "number") {
                args.push(this);
            } else {
                args.push("\"" + this + "\"");
            }
        })
        res["intent"] += args.join(",") + ")";
        if(!$.isEmpty(data.items)) {
            res["components"] = [];
            $.each(data.items, function() {
                var r = _toSaveObj(this);
                if (r !== false) {
                    res["components"].push(r);
                }
            });
        }
        return res;
    };
    var _updateListUpdateByPath = function(p) {
        var rule_edited = p.split("/")[0];
        if ($.inArray(rule_edited, updated_list) === -1) {
            updated_list.push(rule_edited);
        }
    };
    var _getChangesList = function() {
        var del_list = [];
        $.each(initial_data.items, function(k,v) {
            if(!syn_data.items[k]) {
                del_list.push(k);
            }
        });
        $.each(del_list, function(k,v) {
            var l = $.inArray(v, updated_list);
            if (l !== -1) {
                updated_list.splice(l,1);
            }
        });
        var res = {};
        $.each(updated_list, function(k,v) {
            if (typeof(list_data[v]) !== "undefined" ) {
                res[v] = _toSaveObj(syn_data.items[v]);
            }
        });
        return {update_list: JSON.stringify(res), del_list: del_list};
    };
    var DataWrapper = function() {
        $($.recontext(this, this.load));
        window.onbeforeunload = $.recontext(this, this.quit);
    };

    var get_clone_items = function(parent) {
        if (!parent.items) return;
        var res = {};
        $.each(parent.items, function(k, v) {
            res[k] = {};
            $.each(v, function(sk, sv) {
                if (sk === "items") {
                    return;
                }
                res[k][sk] = $.cloneObject(sv);
            });
        });
        return res;
    };
    var __lastUpdate = 1; // No set this value to 0. 0 - is incorrect result on intval php function
    var __in_update = false;
    var __update = function(statrt_new) {
        //console.log(__lastUpdate); //Debug
        if (__in_update) {
            return;
        }
        if (core.Data.isEditing()) {
            if (statrt_new) {
                __startUpdate();
            }
            return;
        }
        __in_update = true;
        $.ajax({
            type: "POST",
            data: {last_updated: __lastUpdate},
            dataType: "json",
            url: core.base_url + "/synergy/update",
            complete: function() {
                __in_update = false;
                if (statrt_new) {
                    __startUpdate();
                }
            },
            success: function(res_data) {
                switch(parseInt(res_data.status)) {
                    case 200: {
                        if (core.Data.isEditing()) break;
                        try {
                            var new_jsno = $.parseJSON(res_data.data.tree);
                        } catch(err) {
                            break;
                        }
                        __lastUpdate = res_data.data.updated;
                        core.Data.update_time();
                        syn_data = new_jsno;
                        initial_data = $.cloneObject(syn_data);
                        list_data = _toList();
                        $($.ns("core.events.DataWrapper")).triggerHandler("data-update");
                        break;
                    }
                    case 304: {
                        // No changes in synergy
                        break;
                    }
                    case 503: {
                        // TODO: fire error message
                        console.error(res_data.data);
                        break;
                    }
                }
            }
        });
    };
    // Function that constantly updates page. Restarted everytime the update runs and page is not being updated.
    var __startUpdate = function() {
        core.refresh_rate = parseInt($("#view-port").attr("data-refresh-rate")) || 2000;
        updateTimer = setTimeout(function() { __update(true); }, core.refresh_rate);
    };
    // Pause the update function after a save has been made. Makes sure old status information is not shown.
    var __pauseUpdate = function() {
        var dateNow = new Date();
        var timeNow = Math.round(dateNow.getTime() / 1000);
        __lastUpdate = timeNow + 10;
        clearTimeout(updateTimer);
        setTimeout(function() { __update(true); }, 10000);
    };
    var a = true;
    DataWrapper.prototype = {
        update: function() { 
            __update(false);
        },
        update_time: function() {
            $("#page_last_update").text($.timeFormat(__lastUpdate));
        },
        load: function() {
            syn_data = $.cloneObject(synergy_data);
            synergy_data = undefined;
            initial_data = $.cloneObject(syn_data);
            list_data = _toList();
            __lastUpdate = parseInt($("#view-port").attr("data-timestamp"));
            __startUpdate();
            $("#sync-button").bind("click", {w: this}, function(e) {
                if ($(this).hasClass("active")) {
                    core.singeltons.AjaxWait.show();
                    e.data.w.sync($.recontext(e.data.w, DataWrapper.prototype.sync_ready));
                }
            });
            $("#undo-button").bind("click", {w: this}, function(e) {
                if ($(this).hasClass("active")) {
                    e.data.w.undo();
                }
            });
        },
        getServerTimestamp: function() {
            return __lastUpdate;
        },
        quit: function() {
            if (this.isEditing()) {
                return "If you leave without saving, all changes will be thrown away. Do you still want to leave this page without saving?";
            }
        },
        toList: function() {
            if (typeof(list_data) !== "undefined") {
                return list_data;
            }
            return list_data = _toList(); 
        },
        isServiceExist: function(service, callback) {
            $.ajax({
                data: {service: service},
                dataType: "json",
                type: "GET",
                url: "/monitor/index.php/synergy/check",
                success: function(res) {
                    if (res.status === 200) {
                        callback(res.data);
                    } else {
                        console.error("Check command fail: ", arguments);
                    }
                },
                error: function() {
                    console.error("XHR request fail: ", arguments);
                }
            });
        },
        isTopLevelExist: function(rule, async, callback) {
            var result;
            async = async ? true : false; // to boolean
            $.ajax({
                async: async || false,
                data: {rule: rule},
                dataType: "json",
                type: "GET",
                url: "/monitor/index.php/synergy/rule_check",
                success: function(res) {
                    if (res.status === 200) {
                        if ((async === true) && (typeof(callback) === "function")) {
                            callback(res.data);
                        } else {
                            result = res.data;
                        }
                    } else {
                        console.error(res.data);
                    }
                },
                error: function() {
                    console.error("XHR request fail: ", arguments);
                }
            });
            if (async === false) {
                return result;
            }
        },
        get: function(url, flat) {
            if(!url) {
                if (flat) {
                    return get_clone_items(syn_data);
                } else {
                    return $.extend({}, syn_data);
                }
            }
            url = url.replace(/^\/+/, "");
            if (typeof(list_data[url]) === "undefined") {
                return false;
            }
            if (flat) {
                return get_clone_items(list_data[url]);
            }
            return $.extend({}, list_data[url]);
        },
        getParentUrl: function(url) {
            var parts = url.split("/");
            parts.pop();
            while(typeof(list_data[parts.join("/")]) === "undefined") {
                if (typeof(parts.pop()) === "undefined") {
                    return false;
                }
            }
            return parts.join("/");
        },
        getParent: function(url) {
            return list_data[this.getParentUrl(url)];
        },
        hasItems: function(p) {
            if (!p) return !$.isEmpty(syn_data.items);
            var r = $.ns_tree("items." + p.split("/").join(".items.")+".items", syn_data);
            if (r === false) {
                return false;
            }
            return !$.isEmpty(r);
        },
        isItemExist: function(p) {
            if (!p) return false;
            if (p === "/") return true;
            p = p.replace(/^\/+/, "");
            return (typeof(list_data[p]) !== "undefined");
        },
        add: function(data, p) {
            p = p || core.url.getCurrent();
            _updateListUpdateByPath(p);
            head = list_data[p];
            if($.isEmpty(head)) { console.error("No path: " + p); return; }
            head.items = head.items || {};
            head.items[data.name] = data;
            list_data[p + "/" + data.name] = head.items[data.name];
            changed();
        },
        add_rule: function(data) {
            _updateListUpdateByPath(data.name);
            syn_data.items[data.name] = data;
            list_data[data.name] = data;
            changed();
        },
        del: function(path) {
            if(!path) return;
            _updateListUpdateByPath(path);
            var obj = this.getParent(path);
            var e = this.get(path);
            if(typeof(obj.items[e.name]) === "undefined") return;
            delete obj.items[e.name];
            delete list_data[path];
            each_sub_element(path, function(k, v) {
                delete list_data[k];
            });
            changed();
        },
        del_rule: function(rule) {
            var i;
            delete syn_data.items[rule];
            delete list_data[rule];
            each_sub_element(rule, function(k, v) {
                delete list_data[k];
            });
            changed();
        },
        clone_rule: function(rule, callback) {
            if(!syn_data.items[rule]) return;
            var new_rule = $.cloneObject(syn_data.items[rule]);
            while(syn_data.items[new_rule["name"]]) {
                new_rule.name += "_clone";
            }
            syn_data.items[new_rule["name"]] = new_rule;
            list_data = _toList();
            _updateListUpdateByPath(new_rule.name);
            changed();
            if (callback) { callback(new_rule) }
        },
        edit: function(data, old_name, p) {
            p = p || core.url.getAddr();
            _updateListUpdateByPath(p);
            head = list_data[p];
            if($.isEmpty(head)) { console.error("No path: " + p); return; }
            data.items = head.items[old_name].items;
            delete head.items[old_name];
            delete list_data[p + "/" + old_name];
            head.items[data.name] = data;
            list_data = _toList();
            changed();
        },
        edit_rule: function(data, old_name) {
            _updateListUpdateByPath(data.name);
            if(!syn_data.items[old_name]) return;
            data.items = syn_data.items[old_name].items;
            delete syn_data.items[old_name];
            delete list_data[old_name];
            syn_data.items[data.name] = data;
            list_data = _toList();
            changed();
        },
        sync: function(callback) {
            if (core.auth_edit === false) return;
            $.ajax({
                data: $.extend(_getChangesList(), _getDiff()),
                dataType: "json",
                type: "POST",
                url: "/monitor/index.php/synergy/sync",
                complete: callback,
                error: function(xhr, type, msg) {
                    $("#notification-board").attr("data-status", "CRITICAL");
                    if (xhr.status === 401) {
                        $("#notification-board").html("Access denied");
                    } else {
                        $("#notification-board").html("Something go wrong");
                    }
                    setTimeout(function() {
                        $("#notification-board").attr("data-status", null).empty();
                        core.Data.undo();
                    }, 2500);
                }
            });
        },
        isEditing: function() {
            return __is_changed;
        },
        sync_ready: function(req) {
            __pauseUpdate();
            core.singeltons.AjaxWait.hide();
            initial_data = $.cloneObject(syn_data);
            list_data = _toList();
            $("#sync-button").removeClass("active");
            $("#undo-button").removeClass("active");
            $("#notification-board").attr("data-status", "OK").html("Your changes are saved!");
            unchange();
            setTimeout(function() {
                $("#notification-board").attr("data-status", null).empty();
            }, 2500);
        },
        undo: function() {
            delete syn_data;
            syn_data = $.cloneObject(initial_data);
            list_data = _toList();
            $("#notification-board").attr("data-status", null).empty();
            $("#sync-button").removeClass("active");
            $("#undo-button").removeClass("active");
            core.url.setAddr(core.url.getCurrent(), true);
            unchange();
        }
    };
    $.ns("core").Data = new DataWrapper();
})(_njq);

//Popup for terminal elements
(function($) {
    var autoWE = function() { return $(this).offset().left > ($(window).width()*0.75) ? 'e' : 'w'; },
        event_ns = $.ns("core.events.TipsyListener"), current, cur_el, just_opened = false,
        TipsyListener = function() {
            $($.recontext(this, this.init));
            $($.ns("core.events.ContentLoader")).bind("load-page", $.recontext(this, this.hide)); 
            $(event_ns).bind("show", $.recontext(this, this.show));
            $(event_ns).bind("hide", $.recontext(this, this.hide));
        };
    TipsyListener.prototype = {
        init: function() {
            $(document.body).bind("click", $.recontext(this, this.hide));
        },
        show: function(e, el, info) {
            if(current) {
                this.hide();
            }
            if(cur_el === el) { cur_el = null; return; }
            cur_el = el;
            current = $(el).tipsy({ trigger: 'manual', fallback: info, html: true, gravity: autoWE, opacity: 1 });
            current.tipsy("show");
            just_opened = true;
            setTimeout(function() { just_opened = false; }, 50);
            $("#terminal-element-popup").bind("click", function(e) { e.stopPropagation(); });
        },
        hide: function() {
            if(just_opened) return;
            if(current) {
                current.tipsy("hide");
            }
        }
    };

    $.ns("core.singeltons").TipsyListener = new TipsyListener();
})(_njq);

// Content Loader
(function($) {
    var element_html = "<div data-url=\"%%URL%%\" class=\"content-element %%TYPE%%\" type=\"%%OBJ%%\"><div class=\"content-element-head\"><span class=\"element-status-text\"></span></div><div class=\"content-element-body\"><span class=\"delete-element\"></span><span class=\"edit-element\"></span><span class=\"content-element-icon\"></span><span class=\"content-element-name\">%%NAME%%</span></div><div class=\"content-element-msg\">%%MSG%%</div><div class=\"clear\"></div></div></div>",
        event_ns = $.ns("core.events.ContentLoader"),
        cont_tmpl = "<b class=\"italic\">\"[[v]]\"</b></br>",
        pages = {},
        tmp = false,
        _dataSeparate = function(data) {
            var result = [{}, {}, {}, {}, {}];
            $.each(data || [], function(k, v) {
                if(v.type != "nagios") {
                    return result[0][k] = v;
                }
                if(v.rule == "host_group_up" || v.rule == "host_group_unfold") {
                    return result[1][k] = v;
                }
                if(v.rule == "service_group_unfold") {
                    return result[2][k] = v;
                }
                if(v.rule == "vhost_up" || v.rule == "host") {
                    return result[3][k] = v;
                }
                return result[4][k] = v;
            });

            return result;
        };
    var ContentLoader = function(node) {
        this.node = $(node);
        $(event_ns).bind("load-page", {w: this}, function(e, p, m) {
            if(m == "flat") {
                e.data.w.show();
                e.data.w.load_page(e, p);
            } else {
                e.data.w.hide();
            }
        });
        $(function(){ tmp = $("#display").children(); });
        $($.ns("core.events.NodeFacet")).bind("facet-change", $.recontext(this, this.render));
        $($.ns("core.events.NewNodeDialog")).bind("node-add", $.recontext(this, this.render));
    };
    ContentLoader.prototype = {
        load_page: function(e, page) {
            var data = core.Data.get(page);
            if (!data) return;
            this.data = data;
            this.page = page;
            this.render(null, null, page);
        },
        render: function(e, filter, page) {
            if (core.url.getMode() !== "flat") return;
            page = page || core.__path;
            filter = filter || false;
            $(".content-element", this.node).remove();
            var filtered_data = core.Data.get(page).items;
            if(filter) {
                filtered_data = $.filterJson(this.data.items, filter);
            }
            var after = $("#nodes-new-element", this.node);
            var sd  = _dataSeparate(filtered_data);
            for(var i = 0; i < sd.length; i++) {
                var that = this;
                $.eachSort(sd[i], "name", function(k, v) {
                    var cont = "";
                    var type = "unknown";
                    if(v.status) {
                        type = v.status.toLowerCase();
                    }
                    obj = "folder";
                    if(v.type === "nagios") obj = v.rule;
                    cont = $.tmpl(cont_tmpl, {v: v.result ? (v.result.msg.length > 58 ? v.result.msg.substring(0,58) + "...": v.result.msg) : "no result yet."});
                    var node = $(element_html.replace("%%URL%%", encodeURIComponent(that.page + "/" + v.name))
                        .replace("%%NAME%%", v.name)
                        .replace("%%TYPE%%", type)
                        .replace("%%OBJ%%", obj)
                        .replace("%%MSG%%", cont));
                    $(".element-status-text", node).html(v.status);
                    if (v.type === "rule") {
                        node.click(function() {
                            core.url.setAddr("/" + decodeURIComponent($(this).attr("data-url")));
                        });
                    }
                    if(actions[v.rule].links) {
                        var links = actions[v.rule].links;
                        if(links.length) {
                            var popup_html = "<div id=\"terminal-element-popup\"><b class=\"bold\">More information:</b></br>";
                            $.each(links, function() {
                                var href = this.href;
                                $.each(actions[v.rule].params, function(i) {
                                    if(this.type == "nagios_service") {
                                        href = href.replace("{{nagios_service.name}}", v.args[i].split("&")[0]).replace("{{nagios_service.description}}", v.args[i].split("&")[1]);
                                    } else {
                                        href = href.replace("{{" + this.name + "}}", v.args[i]);
                                    }
                                });
                                popup_html += "<a href=\""+ core.base_url + href+"\">"+this.title+"</a><br />"
                            });
                            popup_html += "</div>";
                            node.bind("click", {html: popup_html}, function(e) {
                                $(core.events.TipsyListener).triggerHandler("show", [this, e.data.html]);
                            });
                        };
                    }
                    if(core.mode == 1) {
                        that.node.append(node);
                        $(".delete-element").hide();
                        $(".edit-element").hide();
                        $(".content-element-name").attr("style", "padding-top:16px");
                    } else {
                        after.before(node);
                    }
                });
            }
            
            $(".delete-element").bind("click", {w: this}, function(e) {
                if(confirm("Are you sure want to delete this "+$(this).parents(".content-element").attr("type")+"?") == true)
                    e.data.w.delete_element(e, decodeURIComponent($(this).parents(".content-element").attr("data-url")), this);
                e.stopPropagation();
            });
            $(".edit-element").bind("click", {w: this}, function(e) {
                e.data.w.edit_element(e, decodeURIComponent($(this).parents(".content-element").attr("data-url")), this);
                e.stopPropagation();
            });
            this.node.append($("<div class=\"clear\"></div>"));
        },
        delete_element: function(e, url, el) {
            core.Data.del(url);
            $(el).parents(".content-element").remove();
        },
        edit_element: function(e, url) {
            var el = core.Data.get(url);
            $(core.events.ModalWindow).triggerHandler("show", [$("#modal-windows #new-node-win")]);
            $(core.events.NewNodeDialog).triggerHandler("show-dialog", [el.rule, el]);
        },
        show: function() {
            $("#display").append(tmp);
        },
        hide: function() {
            tmp = tmp.detach();
        }
    };
    $.ns("core.classes").ContentLoader = ContentLoader;
})(_njq);

// Scroll
(function($) {
    var event_ns = $.ns("core.events.Scroll");
    var wrapper_html = "<div></div>";
    var elem_html = "<div class=\"slider-element [[sl]]\" data-url=\"[[n]]\"><div class=\"slider-element-header\">[[su]]</div><div class=\"slider-element-body\">[[n2]]</div></div></div>";
    var scroll_step = 200;
    var Scroll = function(node) {
        this.node = $(node);
        this.left = 0;
        this.render_elements(this.node);
        $(event_ns).bind("move-left", $.recontext(this, this.move_left));
        $(event_ns).bind("move-right", $.recontext(this, this.move_right));
        $($.ns("core.events.NewNodeDialog")).bind("rule-add", {w:this}, function(e) {
            e.data.w.render_elements(e.data.w.node);
        });
        this.select_current(core.__path.split("/")[0]);
    };
    Scroll.prototype = {
        render_elements: function(node) {
            node.children().remove();
            var data = core.Data.get(), that = this;
            $.each(data.items, function(k, v) {
                node.prepend($.tmpl(elem_html, {
                    "sl": v.status.toLowerCase(),
                    "su": v.status.toUpperCase(),
                    "n": encodeURIComponent(k),
                    "n2": k
                }));
            });
            node.css({ position: "relative", overflow: "hidden" });
            this.sub_wrapper = $(wrapper_html).append(node.children().remove()).css("float", "left");
            this.wrapper = $(wrapper_html).append(this.sub_wrapper).appendTo(node).css({position: "absolute", "top": 0, "left": 0, "width": "10000px", "clear": "both"});
            if(core.mode == 2) {
                $(this.sub_wrapper).append("<div class=\"add-new-rule\" id=\"add-new-rule\"></div>");
                document.getElementById("add-new-rule").onclick = function() {
                    $(core.events.ModalWindow).triggerHandler("show", [$("#modal-windows #new-node-win"), true]); 
                };
            }
            $(".slider-element").each(function() {
                this.onclick = function() { 
                    core.url.setAddr("/" + decodeURIComponent($(this).attr("data-url")), true);
                }
            });
            $($.ns("core.events.ContentLoader")).bind("load-page", {w:this}, function(e, url) {
                e.data.w.select_current(url.split("/")[0]);
            });
            this.select_current(core.__path.split("/")[0]);
        },
        move_right: function() {
            var diff = (this.sub_wrapper.width() + this.left) - this.node.width();
            if (diff > 0) {
                var step = 0;
                if (diff >= scroll_step) {
                    step = scroll_step;
                } else {
                    step = diff;
                }
                this.left -= step;
                this.wrapper.animate({
                    left: "-=" + step
                }, 250);
                //this.wrapper.css("left", this.left + "px");
            } else {
                $(event_ns).triggerHandler("no-right", [this]);
            }
        },
        move_left: function() {
            if (this.left != 0) {
                var step = 0;
                if ((-this.left) >= scroll_step) {
                    step = scroll_step;
                } else {
                    step = -this.left;
                }
                this.left += step;
                this.wrapper.animate({
                    left: "+=" + step
                }, 250);
                //this.wrapper.css("left", this.left + "px");
            } else {
                $(event_ns).triggerHandler("no-left", [this]);
            }
        },
        select_current: function(current_rule) {
            $(".slider-element").removeClass("selected");
            $(".slider-element[data-url=\""+encodeURIComponent(current_rule)+"\"    ]").addClass("selected");
        }
    };
    $.ns("core.classes").Scroll = Scroll;
})(_njq);

// BreadCrumbs
(function($) {
    var element_html = "<div class=\"breadcrumbs-element %%TYPE%%\" data-url=\"%%URL%%\"></div>";
    var BreadCrumbs = function(node) {
        this.node = $(node);
        $($.ns("core.events.ContentLoader")).bind("load-page", $.recontext(this, this.render));
    };
    BreadCrumbs.prototype = {
        render: function(e, addr) {
            if(core.url.getMode() == "tree") return;
            addr = core.url.getAddr();
            window.core.__path = decodeURIComponent(addr);
            var pieces = addr.split('/'), list_data = core.Data.toList();
            this.node.empty();
            var url = "";
            for (var i = 0; i < pieces.length; i++) {
                url += pieces[i] + "/";
                var type = list_data[url.slice(0, -1)]["status"].toLowerCase();
                var el = $((element_html + "").replace("%%URL%%", encodeURIComponent(url.slice(0, -1))).replace("%%TYPE%%", type));
                if (i + 1 == pieces.length) {
                    el.addClass("last").html(pieces[i]);
                } else {
                    el.html(pieces[i]);
                    el.click($.recontext(el, this.select));
                }
                this.node.append(el);
            }
            this.node.append($("<div class=\"clear\"></div>"));
        },
        // this -> .breadcrumbs-element
        select: function() { 
            core.url.setAddr("/" + decodeURIComponent(this.attr("data-url")));
        }
    };
    $.ns("core.classes").BreadCrumbs = BreadCrumbs;
})(_njq);

// CurrentNode
(function($) {
    var cont_tmpl = "<b class=\"bold\">[[k]]</b>: [[v]]</br>";
    var CurrentNode = function(node) {
        this.node = $(node);
        $($.ns("core.events.ContentLoader")).bind("load-page", $.recontext(this, this.render));
    };
    CurrentNode.prototype = {
        render: function(e, addr) {
            if(core.url.getMode() == "tree") return;
            var data = core.Data.get(addr), last_check = last_state_change = "No result yet";
            var cont, conf = "";
            if(core.mode == 2) {
                conf = "<span class=\"delete-node-link\" data-url=\""+encodeURIComponent(core.__path)+"\"></span>";
                conf += "<span class=\"edit-node-link\" data-url=\""+encodeURIComponent(core.__path)+"\"></span>";
                if(core.__path.split("/").length === 1) {
                    conf += "<span class=\"clone-node-link\" data-url=\""+encodeURIComponent(core.__path)+"\">clone</span>";
                }
            }
            $("#current-head",this.node).html("<span class=\"current-top-node-icon\"></span><span id=\"current-top-node-name\">"+data.name+"</span>"+conf+"<div class=\"clear\"></div>");
            this.node.attr("data-type", data.status.toLowerCase());
            cont = $.tmpl(cont_tmpl, {v: data.status+"<span id =\"status-shild\"></span>", k: "status" });
            cont += $.tmpl(cont_tmpl, {v: actions[data.rule].name, k: "rule"});
            $.each(actions[data.rule].params, function(i) {
                cont += $.tmpl(cont_tmpl, {v: data.args[i], k: this.name});
            });
            if(data.result) {
                last_check = new Date(data.result.last_check *1000 );
                last_check = last_check.toLocaleTimeString()+' '+last_check.toDateString();
                last_state_change =  new Date(data.result.last_state_change * 1000);
                last_state_change = last_state_change.toLocaleTimeString()+' '+last_state_change.toDateString();
            }
            cont += $.tmpl(cont_tmpl, {v: data.result ? data.result.msg : "no result yet.", k: "message"});
            cont += $.tmpl(cont_tmpl, {v: last_check, k: "Last ckeck"} );
            cont += $.tmpl(cont_tmpl, {v: last_state_change, k: "Last state change" } );
            $("#current-body", this.node).html(cont);
            $(".delete-node-link", this.node).click(function() {
                if(confirm("Are you sure want to delete?") == false) {
                    return;
                }
                core.Data.del_rule(decodeURIComponent($(this).attr("data-url")), function() {
                    core.url.setAddr("/");
                    $(core.events.NewNodeDialog).triggerHandler("rule-add");
                });
            });
            $(".edit-node-link").click(function() {
                el = core.Data.get(core.__path);
                $(core.events.ModalWindow).triggerHandler("show", [$("#modal-windows #new-node-win"), "NewNodeDialog", true]);
                $(core.events.NewNodeDialog).triggerHandler("show-dialog", [el.rule, el]);
            });
            $(".clone-node-link").click(function() {
                core.Data.clone_rule(decodeURIComponent($(this).attr("data-url")), function() {
                    core.url.setAddr(this.new_rule_name);
                    $(core.events.NewNodeDialog).triggerHandler("rule-add");
                    $(".edit-node-link").triggerHandler("click");
                }, this);
            });
        }
    };
    $.ns("core.classes").CurrentNode = CurrentNode;
})(_njq);

// Node Facet
(function($) {
    var event_ns = $.ns("core.events.NodeFacet");
    var reg_exp = /[\w\d_]+/i;
    var NodeFacet = function(node) {
        this.node = $(node);
        this.filter = {};
        this.check_buttons = $(".facet-element-toggle", this.node);
        this.quick_search = $("#quick-filter", this.node);
        this.quick_search.bind("change", $.recontext(this, this.text_change));
        this.quick_search.bind("keyup", $.recontext(this, this.text_change));
        this.check_buttons.bind("change", $.recontext(this, this.radio_change));
        this.check_buttons.click(function() { if($(this).hasClass("toggle")) { $(this).removeClass("toggle"); } else { $(this).addClass("toggle"); } $(this).triggerHandler("change"); } );
    };
    NodeFacet.prototype = {
        text_change: function() {
            var val = this.quick_search.val();
            if(!reg_exp.test(val)) {
                delete this.filter["name"];
            } else {
                this.filter["name"] = "~"+val;
            }
            $(event_ns).triggerHandler("facet-change", [this.filter]);
        },
        radio_change: function() {
            var values = [];
            $.each(this.check_buttons.filter(function() { return $(this).hasClass("toggle"); }), function() { values.push($(this).attr("data-type")); });
            if(values.length === 3) {
                delete this.filter["status"];
            } else {
                this.filter["status"] = values;
            }
            $(event_ns).triggerHandler("facet-change", [this.filter]);
        }
    };
    $.ns("core.classes").NodeFacet = NodeFacet;
})(_njq);

// Live Search
(function($) {
    var reg_exp = /[\w\d_]+/i;
    var element_html = "<div class=\"search-result [[s]]\" data-url=\"[[e]]\"><span class=\"result-name\">[[n]]</span><span class=\"result-url\">[[u]]</span><span class=\"result-status [[t]]\">[[s]]</span></div>";
    var max_result = 5,
        open_link = function(e) {
            var url = decodeURIComponent($(this).attr("data-url")), eu = $(this).attr("data-url");
            if (!core.Data.hasItems(url)) {
                url = core.Data.getParentUrl(url);
            }
            core.url.setAddr(url, true);
            $('html, body').animate({
                scrollTop: $(".tree-wrapper [data-url=\""+eu+"\"]").offset().top
            }, 1000);
            e.data.w.hide_popup();
            e.stopPropagation();
        };
    var LiveSearch = function(node) {
        this.node = $(node).click(function(e) { e.stopPropagation(); });
        this.popup = $("<div></div>");
        this.popup.css({
            position: "absolute",
            top: 35,
            right: "4px",
            "border": "1px solid #D0D0D0",
            "z-index": "100",
            display: "none"
        }).appendTo(this.node.parent());
        this.node.bind("keyup", $.recontext(this, this.search));
        this.node.bind("change", $.recontext(this, this.search));
        this.node.bind("focus", $.recontext(this, this.search));
        $("body").bind("click", $.recontext(this, this.hide_popup));
    };
    LiveSearch.prototype = {
        search: function(e) {
            var val = this.node.val();
            if(reg_exp.test(val)) {
                this.show_popup($.filterJson(core.Data.toList(), { name: "~" + val }), val);
            } else {
                this.hide_popup();
            }
        },
        show_popup: function(list, search_val) {
            var scores_list = [], count = 0, that = this;
            $.each($.objectKeys(list) || {}, function(k, v) {
                if (count === 5) return;
                scores_list.push({key: v, score: LiquidMetal.score(key, search_val)});
                count++;
            });
            if (!scores_list.length) return this.hide_popup();
            this.popup.empty();

            $.eachSort(scores_list, "score", function(k, v) {
                var v = list[v.key];
                that.popup.append($($.tmpl(element_html, {
                    n: v.name,
                    u: v.url,
                    e: encodeURIComponent(v.url),
                    t: v.status.toLowerCase(),
                    s: v.status
                })).bind("click", {w: that}, open_link));
            });
            this.popup.show();
        },
        hide_popup: function() {
            this.popup.empty();
            this.popup.hide();
        }
    };
    $.ns("core.classes").LiveSearch = LiveSearch;
})(_njq);

// Modal Window
(function($) {
    var ModalWindow = function() {
        $($.recontext(this, this.init));
        $($.ns("core.events.ModalWindow")).bind("hide", $.recontext(this, this.hide));
        $($.ns("core.events.ModalWindow")).bind("show", $.recontext(this, this.show));
        $($.ns("core.events.NewNodeDialog")).bind("show-dialog", function() { 
            setTimeout($.colorbox.resize, 100);
        });
        $($.ns("core.events.ModalWindow")).bind("show", function() { 
            $.colorbox.resize(); 
        });
    };
    ModalWindow.prototype = {
        init: function() {
        },
        show: function(e, element, is_new_rule) {
            $(element).attr({ "data-new-rule": is_new_rule ? "1" : "0" });
            $.colorbox({inline: true, href: element, close: false, height: 300, onComplete: function() { $.colorbox.resize(); }});
            $('.close-win-button', element).bind("click", function() {$(core.events.ModalWindow).triggerHandler("hide");}); 
        },
        hide: function() {
            $.colorbox.close();
        }
    };
    $.ns("core.singeltons").ModalWindow = new ModalWindow();
})(_njq);

// Validation init
(function($) {
    var 
    ValidationInit = function(form, action) {
        var rules = {};
        if(!actions[action]) { console.error("Try validate anknown action", action); return; }
        if(actions[action].tag !== "nagios") {
            rules["name"] = {
                required: true, 
                unique_in_scope: true,
                not_allowed_chars: "/\\[]\"'{}&<>", 
                unique_on_server: true };
        }
        $.each(actions[action].params, function() {
            rules[this.name] = this.validation;
        });
        $(form).validate({
            debug: true,
            ignore: ".flexselect, .multiflexselect, .ignore, .is-use",
            rules: rules,
            submitHandler: function() {
                var m;
                if ((m = $("#new-node-win #materialized")).val()) {
                    core.Data.isServiceExist(m.val()+"&"+$("#new-node-win #name").val(), function(exist) {
                        if (exist) {
                            if (confirm("Service with the same name already exist. Do you still want to use it?")) {
                                $($.ns("core.events.NewNodeDialog")).triggerHandler("create", [$(form).serializeArray()]);
                            } else {
                                return;
                            }
                        } else {
                            $($.ns("core.events.NewNodeDialog")).triggerHandler("create", [$(form).serializeArray()]);
                        }
                    });
                    return;
                }
                $($.ns("core.events.NewNodeDialog")).triggerHandler("create", [$(form).serializeArray()]);
            },
            errorPlacement: function(error, element) {
                error.appendTo(element.parents(".field-wrapper").find(".error-wrapper"));
            }
        });
        
    };
    $.ns("core.functions").ValidationInit = ValidationInit;
    _njq.validator.addMethod("unique_in_scope", function(value, element) {
        var v = value;
        var old = $(element).parents(".new-node-form").find("[name=\"old_name\"]");
        if ($(element).attr("id") === "nagios_service") {
            v = value.split("&")[1] + " on " + value.split("&")[0];
        }
        if ($(element).attr("id") === "nagios_host_services") {
            v = "Services on " + value;
        }
        if (old.val() === v) {
            return true;
        }
        return !core.Data.isItemExist((parseInt($("#new-node-win").attr("data-new-rule")) === 1) ? v : (core.url.getCurrent() + "/" + v));
    }, "Sorry, element with the same name exist in this scope.");
    _njq.validator.addMethod("not_allowed_chars", function(value, element, chars) {
        for (var i = 0; i < value.length; i++) {
            if (chars.indexOf(value[i]) !== -1) {
                return false;
            }
        }
        return true;
    }, _njq.format("These symbols are not allowed in names: {0}"));
    _njq.validator.addMethod("unique_on_server", function(value, element, chars) {
        if (1 !== parseInt($(element).parents("#new-node-win").attr("data-new-rule"))) {
            return true;
        }
        var old = $(element).parents(".new-node-form").find("[name=\"old_name\"]"), v = value;
        if (1 !== parseInt($(element).parents("#new-node-win").attr("data-new-rule"))) {
            return true;
        }
        if ($(element).attr("id") === "nagios_service") {
            v = value.split("&")[1] + " on " + value.split("&")[0];
        }
        if ($(element).attr("id") === "nagios_host_services") {
            v = "Services on " + value;
        }
        if (old.val() === v) {
            return true;
        }
        return !core.Data.isTopLevelExist(value, false);
    }, _njq.format("Sorry, element with the same name exist on server."));
})(_njq);

// New Node Dialog
(function($) {
    var is_opened = false;
    var event_ns = $.ns("core.events.NewNodeDialog"), prev_page, cur_page;
    var NewNodeDialog = function(node) {
        this.node = $(node);
        this.dialog = $("#dialog-new-node");
        
        $(event_ns).bind("show-dialog", $.recontext(this, this.show_dialog));
        $(event_ns).bind("create", $.recontext(this, this.create));
        $(document).bind('cbox_closed', $.recontext(this, this.hide_dialog));
        $(core.events.ModalWindow).bind("hide", $.recontext(this, this.hide_dialog));
    };
    NewNodeDialog.prototype = {
        create: function(e, data) {
            var new_data = {}, old_name;
            $.each(data, function() {
                 new_data[this.name] = this.value;
            });
            data = new_data;
            if(!data["items"]) {
                data["items"] = {};
            }
            if(data["type"] === "service") {
                delete data["items"];
            }
            data["status"] = "UNKNOWN";
            if($.inArray(data["rule"], ["host", "host_services", "service", "service_group", "host_group"]) !== -1) {
                data["type"] = "nagios";
                delete data["items"];
            } else {
                data["type"] = "rule";
            }
            if(!data["name"]) {
                if(data["nagios_host"]) {
                    data["name"] = data["nagios_host"];
                }
                if(data["nagios_host_services"]) {
                    data["name"] = "Services on " + data["nagios_host_services"];
                }
                if(data["nagios_service"]) {
                    var p = data["nagios_service"].split("&");
                    data["name"] = p[1] + " on " + p[0];
                }
                if(data["nagios_hostgroup"]) {
                    data["name"] = data["nagios_hostgroup"];
                }
                if(data["nagios_servicegroup"]) {
                    data["name"] = data["nagios_servicegroup"];
                }
            }
            if (data["materialized"]) {
                data["materialized"] = {host: data["materialized"]};
            } else {
                delete data["materialized"];
            }
            data.args = [];
            $.each(actions[data.rule].params, function() {
                data.args.push(data[this.name]);
                delete data[this.name]; 
            });
            var is_rule_add =  parseInt(this.dialog.parents("#new-node-win").attr("data-new-rule"));
            if (is_rule_add) {
                if (data["is_edit"]) {
                    old_name = data["old_name"];
                    delete data["old_name"];
                    delete data["is_edit"];
                    core.Data.edit_rule(data, old_name);
                    $(event_ns).triggerHandler("rule-add");
                    core.url.setAddr("/" + data.name);
                } else {
                    core.Data.add_rule(data);
                    $(event_ns).triggerHandler("rule-add");
                    core.url.setAddr("/" + data.name);
                }
            } else {
                if (data["is_edit"]) {
                    old_name = data["old_name"];
                    delete data["is_edit"];
                    core.Data.edit(data, old_name);
                } else {
                    core.Data.add(data);
                }
                $(event_ns).triggerHandler("node-add");
            }
            $(core.events.ModalWindow).triggerHandler("hide");
            this.hide_dialog();
        },
        show_dialog: function(e, type, obj) {
            var edit_path = $("#new-node-win").attr("data-change");
            if (edit_path) {
                $("#new-node-win").attr("data-change", null);
            }
            is_opened = true;
            $(".win-title").text("Configure element");
            $(event_ns).triggerHandler("show-current");
            prev_page = (p = $(".modal-win-body", this.node)).children().detach();
            if(edit_path) {
                obj = core.Data.get(edit_path);
            }
            var new_dialog = this.dialog.clone();
            this.dialog.after(new_dialog);
            this.dialog.remove(); 
            this.dialog = new_dialog;
            $(".change-action", this.dialog).bind("click", {w:this}, function(e) {
                e.data.w.hide_dialog(e, true);
            });
            this.dialog.find("#type").val(type);
            $(".configure-content", this.dialog).empty();
            $(".configure-content", this.dialog).append($.ns("core.templates.dialog_configs")[type]);
            p.append(this.dialog);
            if(obj) {
                if (obj.materialized) {
                    $("#materialized [value=\""+obj.materialized.host+"\"]", this.dialog).attr("data-populate", "1");
                }
                $("input[type=\"submit\"]", this.dialog).val("save");
                $("input[name=\"name\"]", this.dialog).val(obj.name);
                $(".configure-content")
                    .append($("<input type=\"hidden\" name=\"is_edit\" value=\"1\" />"))
                    .append($("<input type=\"hidden\" name=\"old_name\" value=\""+obj.name+"\" />"));
                var w = this;
                var cur_action = actions[obj.rule];
                if(obj.args) {
                    $.each(obj.args, function(indx, val) {
                        if (!cur_action.params[indx]) {
                            return;
                        }
                        if(cur_action.params[indx]) {
                            $("input[name=\"" + cur_action.params[indx].name + "\"]", w.dialog).val(val);
                        }
                        if (cur_action.params[indx].type == "enum") {
                            $("#"+cur_action.params[indx].name+" [value=\""+val+"\"]", this.dialog).attr("selected", "selected");
                        }
                        if($.inArray(cur_action.params[indx].type, ["nagios_host", "nagios_service", "nagios_hostgroup", "nagios_servicegroup"]) !== -1) {
                            $("#" + cur_action.params[indx].type + " [value=\""+val+"\"]", this.dialog).attr("data-populate", "1");
                        }
                    });    
                }
            }
            $("select.flexselect", this.dialog).flexselect();
            $("#materialized", this.dialog).parents(".field-wrapper").materialized();
            // $("input.flexselect", this.dialog).val(null);
            $("select.multi-flexselect", this.dialog).multiflexselect();
            $.insertValues(this.dialog, {
                ".action-name": actions[type].name,
                ".action-descript": actions[type].description
            });
            $(".rule", this.dialog).val(type);
            core.functions.ValidationInit($("form.new-node-form", this.dialog), type);
        },
        hide_dialog: function(e, remember) {
            if(is_opened) {
                var p, edit = $("input[name=\"old_name\"]", this.node);
                cur_page = (p = $(".modal-win-body", this.node)).children().detach();
                $(".modal-win-body", this.node).append(prev_page);
                $.colorbox.resize();
                if (remember) {
                    var data_url = core.url.getCurrent() !== "/" ? core.url.getCurrent() + "/" + edit.val() : edit.val();
                    $(event_ns).triggerHandler("show-prev", [edit.length ? data_url : false]);
                } else {
                    this.node.attr("data-change", null);
                    $(event_ns).triggerHandler("show-prev");
                }
            }
            is_opened = false;
        }
    };
    $.ns("core.classes").NewNodeDialog = NewNodeDialog;
})(_njq);

// Dialog Config
(function($) {
    var form_entety = "<tr class=\"field-wrapper\"><td class=\"field-description field-part\"><label for=\"[[n]]\">[[l]]: </label><br\><span class = \"action-field-hint\">[[h]]</span></div>";
        form_entety += "<td class=\"field-input field-part\">[[i]]</td>";
        form_entety += "<td class=\"field-messages field-part\"><span class=\"error-wrapper\"></span></td></tr>";
    var DialogConfig = function(action, act_name) {
        res = "";
        if(action.tag !== "nagios") {
            res = $.tmpl(form_entety, {n: "Name", l: "Name", h: "Object name displayed in Business Services", i: "<input type=\"text\" name=\"name\" id=\"name\" />"});
        } else {
            action.params.push({
                hint: "State type",
                label: "State type",
                name: "state_type",
                type: "enum",
                values: ["hard", "all"]
            });
        }
        var input = "";
        for(var key in action.params) {
            switch(action.params[key]["type"]) {
                case "number":
                case "string":
                input = $.tmpl("<input type=\"text\" id=\"[[n]]\" name=\"[[n]]\"/>", { "n": action.params[key]["name"] });
                break;
                case "enum":
                input = $.tmpl("<select id=\"[[n]]\" name=\"[[n]]\">", { "n": action.params[key]["name"] });
                for(var e_index in action.params[key]["values"]) {
                    input += $.tmpl("<option value=\"[[v]]\">[[v]]</option>", {"v": action.params[key]["values"][e_index]});
                }
                input += "</select>";
                break;
                case "boolean":
                input = $.tmpl("<input type=\"checkbox\" name=\"[[n]]\" id=\"[[n]]\" />", { "n": action.params[key]["name"] });
                break;
                case "nagios_host":
                input = $.tmpl(core.Nagios.get("hosts"), {n: action.params[key]["name"]});
                break;
                case "nagios_hostgroup":
                input = $.tmpl(core.Nagios.get("hostgroups"), {n: action.params[key]["name"]});
                break;
                case "nagios_servicegroup":
                input = $.tmpl(core.Nagios.get("servicegroups"), {n: action.params[key]["name"]});
                break;
                case "nagios_service":
                input = $.tmpl(core.Nagios.get("services"), {n: action.params[key]["name"]});
                break;
            }
            res += $.tmpl(form_entety, {"n": action.params[key]["name"], "l": action.params[key]["label"], "h": action.params[key]["hint"], "i": input});
        }
        if(action.tag === "synergy_group") {
            res += $.tmpl(form_entety, { 
        n: "Materialized",
        l: "as a Service at",
                h: "Associate with host for reporting and notification", 
                i:  $.tmpl(core.Nagios.get("hosts"), {n: "materialized"})
            });
        }
        $.ns("core.templates.dialog_configs")[act_name] = res;
    }
    $.ns("core.classes").DialogConfig = DialogConfig;
})(_njq);

// UI FIX
(function($) {
    var resize = function() {
        $("#current-node-top").css("height", parseInt($(window).height()) - 235);
    };
    $(window).bind("resize", $.recontext(window, resize));
    $($.recontext(window, resize));
})(_njq);

// New Element List
(function($){
    var event_ns = $.ns("core.events.NewElementList"), is_edit = false;
    var action_html = "<div class=\"new-node-element\" data-type=\"[[t]]\"><div class=\"new-action-body\"><div class=\"new-action-icon\"></div><span class=\"new-action-name\">[[n]]</span><div class=\"clear\"></div></div><div><span class=\"new-action-description\">[[d]]</span></div></div>";
    var action_items = {};
    var detached;
    var not_syn_groups;
    var NewElementList = function(parent) {
        this.parent = $(parent);
        $(event_ns).bind("show", $.recontext(this, this.show));
        $(core.events.ModalWindow).bind("show", {w: this}, function(e, el, t) { 
            if (parseInt(e.data.w.parent.attr("data-new-rule")) === 1) {
                e.data.w.render(true);
            } else {
                e.data.w.render();
            }
            if(t === "NewNodeDialog") { 
                $(".win-title").text("Select");
            } 
        });
        $(core.events.NewNodeDialog).bind("show-prev", {w: this}, function(e, ie) {
            $(".win-title").text("Select");
            e.data.w.parent.attr("data-change", ie ? ie : null);
        });
        $("#display").on("click", "#nodes-new-element", function() {
            $(core.events.ModalWindow).triggerHandler("show", [$("#modal-windows #new-node-win")]);
        });
        this.parent.on("click", ".new-node-element", function() {
            $(core.events.NewNodeDialog).triggerHandler("show-dialog", [$(this).attr("data-type")]);
        });
        not_syn_groups = $(".action-tag-group").not(".tag-synergy_group").clone();
        this.render();
    };
    NewElementList.prototype = {
        render: function(top_level) {
            top_level = top_level ? true : false;
            $(".new-node-element", this.parent).remove();
            if (top_level) {
                $(".action-tag-group").not(".tag-synergy_group").remove();
            } else {
                if ($(".action-tag-group").not(".tag-synergy_group").length == 0) {
                    $(".modal-win-body").append(not_syn_groups);
                }
            }
            $.eachSort(actions, "order", function(k, v) {
                $(".tag-" + v["tag"]+">.group-wrapper>.clear").before($($.tmpl(action_html, { t: k, n: v["name"], d: v["description"] })));
            });
        }
    };
    $.ns("core.classes").NewElementList = NewElementList;
})(_njq);

// Nagios
(function($) {
    var objects = {},
    Nagios = function() {
        $($.recontext(this, this.init));
    };
    Nagios.prototype = {
        init: function() {
            var types = ["hosts", "hostgroups", "servicegroups"];
            for(var i = 0; i < types.length; i++) {
                if(!objects[types[i]]) {
                    var res = "<select name=\"[[n]]\" class=\"flexselect\" id=\"[[n]]\">";
                    $.each(nagios[types[i]], function(k, v) {
                        res += "<option value=\""+k+"\">"+k+"</option>";
                    });
                    res += "</select>";
                    objects[types[i]] = res;
                }
            }
            if (!objects["services"]) {
                objects["services"] = "<select name=\"[[n]]\" class=\"multi-flexselect\" id=\"[[n]]\">";
                $.each(nagios.services, function(k, v) {
                    $.each(v, function() {
                        objects["services"] += "<option value=\""+k+"&"+this+"\">"+k+"&"+this+"</option>";
                    })
                });
                objects["services"] += "</select>";
            }
        },
        get: function(name) {
            if(!objects[name]) {
                return;
            }
            return objects[name];
        }
    };
    core.Nagios = new Nagios();
})(_njq);

// Ajax Wait
(function($) {
    var AjaxWait = function() {
        $(event_ns).bind("show", $.recontext(this, this.show));
        $(event_ns).bind("hide", $.recontext(this, this.hide));
        $(window).bind("resize", $.recontext(this, center));
    }, event_ns = $.ns("core.events.AjaxWait"),
        node = $("<div id=\"wait-modal-wrapper\"></div>"),
        cont = $("<div id=\"modal-content-wrapper\"><span class=\"loading\">Saving...</span></div>"),
        hide_div = "<div id=\"hide-all-wrapper\"></div>",
        dt,
        is_showed = false,
        center = function() {
            if(!is_showed) return;
            cont.css({
                left: (node.width() / 2) - (cont.width() / 2),
                top: (node.height() / 2) - (cont.height() / 2)
            });
        };
    AjaxWait.prototype = {
        show: function(e) {
            if(is_showed) return;
            dt = $(document.body).children().detach();
            var hd = $(hide_div).append(dt);
            hd.appendTo(document.body);
            $(document.body).append(node);
            $("#menu").css("overflow", "hidden");
            $(document.body).append(cont);
            is_showed = true;
            $(document.body).trigger("resize");
        },
        hide: function() {
            if(!is_showed) return;
            node.detach();
            cont.detach();
            $(document.body).append(dt);
            $("#hide-all-wrapper").remove();
            $("#menu").css("overflow-y", "auto");
            is_showed = false;
        }
    }
    $.ns("core.singeltons").AjaxWait = new AjaxWait();
})(_njq);

// Action Builder
(function($) {
    var cfl = function(string) {
        return string.charAt(0).toUpperCase() + string.slice(1);
    }
    var action_tmpl = '<a class="action-button [[t]]" onclick="return false;" title="[[h]]"></a>';
    var compile = function(items) { 
        var res = ""; 
        $.each(items, function() { 
            var hint = this;
            if (this == "add") {
                hint += " subelement";
            }
            res += $.tmpl(action_tmpl, {t: this, h: cfl(hint)}) 
        }); 
        return res; 
    }, toHtml = function(node) {
        return ($("<div></div>").append(node))[0].innerHTML;
    }, compile_link = function(el, indx) {
        var links = actions[el.rule].links || [];
        var link = $.cloneObject(links[indx]);
        $.each(actions[el.rule].params, function(i) {
            if (el.rule !== "service" && this.name !== "nagios_service") {
                link.href = link.href.replace("{{"+this.name+"}}", el.args[i]);
            } else {
                var host_service = el.args[i].split("&");
                link.href = link.href
                    // URI encode host_service to get the ninja and nacoma links to work if special chars has been used
                    .replace("{{nagios_service.name}}", encodeURIComponent(host_service[0]))
                    .replace("{{nagios_service.description}}", encodeURIComponent(host_service[1]));
            }
        });
        return link;
    };
    var t_actions_tmpl = compile(["view", "configure", "add", "edit", "delete", "clone"]), actions_tmpl,
        noauth_tmpl = compile(["view"]);
    $.ns("core.functions").ActionBuilder = function(el, is_top_level) {
        actions_tmpl = $(core.auth_edit ? t_actions_tmpl : noauth_tmpl);
        var a = 1;
        if ($.isEmpty(el.materialized) && el.type !== "nagios") {
            actions_tmpl.filter(".configure").css("visibility", "hidden");
        }
        if (actions[el.rule].tag == "synergy_group") {
            if (!$.isEmpty(el.materialized)) {
                var e = actions_tmpl.filter(".configure").css("visibility", "visible").attr("onclick", null);
                e.attr({
                    title: "Service configure",
                    // URI encode names to get the ninja and nacoma links to work if special chars has been used
                    href: core.base_url + "/configuration/configure/service/"+encodeURIComponent(el.materialized.host)+"?service="+encodeURIComponent(el.name)
                });
                var view_e = actions_tmpl.filter(".view").css("visibility", "visible").attr("onclick", null);
                view_e.attr({
                    title: "Service details",
                    // URI encode names to get the ninja and nacoma links to work if special chars has been used
                    href: core.base_url + "/extinfo/details/service/"+encodeURIComponent(el.materialized.host) + "?service=" + encodeURIComponent(el.name)
                });
                if (!is_top_level) {
                    actions_tmpl.filter(".clone").css("visibility", "hidden");
                }
                return toHtml(actions_tmpl);
            }
            if(is_top_level) {
                actions_tmpl.filter(".view").css("visibility", "hidden");
                return toHtml(actions_tmpl);
            }
            actions_tmpl.filter(".view, .clone").css("visibility", "hidden");
            return toHtml(actions_tmpl);
        }
        var links = actions[el.rule].links || [], res = actions_tmpl.filter(".add, .clone, .view").css("visibility", "hidden");
        if (links.length === 0) return toHtml(actions_tmpl);
        var view_link = compile_link(el, 0), conf_link = compile_link(el, 1);
        var ve = actions_tmpl.filter(".view").css("visibility", "visible").attr("onclick", null);
        var ce = actions_tmpl.filter(".configure").css("visibility", "visible").attr("onclick", null);
        ve.attr({
            "title": cfl(view_link.title),
            "href": core.base_url+view_link.href
        });
        ce.attr({
            "title": cfl(conf_link.title),
            "href": core.base_url+conf_link.href
        });
        return toHtml(actions_tmpl);
    }
})(_njq);

// Tree view
(function($) {
    var tmpl = "<table class=\"tree-wrapper\"><thead><tr><th><div>Business Object</div><div><a class=\"expand-all\" onclick=\"return false;\" title=\"Expand all\"></a></div><div><a class=\"collapse-all\" onclick=\"return false;\" title=\"Collapse all\"></a></div><div class=\"clear\"></div></th><th>Rule</th><th>Actions</th><th>Last check</th><th>duration</th><th>Status information</th></tr></thead><tbody><tr class=\"start-point\"></tr></tbody></table>", elements, c;
    elem_temp = '<tr data-url="[[u]]" data-level="[[l]]"><td class="obj-name [[s]]"><span class="margin"></span><span class="arrow"></span><a class="shild-img" title="[[h]]"></a><span class="name">[[n]]</span></td><td>[[r]] [[a]]</td><td class="obj-actions">[[d]]</td><td class="obj-last-check">[[lc]]</td><td class="obj-last-state-change">[[lstate]]</td><td>[[m]]</td></tr>',
        statuses_hists = {
            "host": {
                0: "UP",
                1: "DOWN",
                2: "UNREACHABLE",
                6: "PENDING"
            },
            "service": {
                0: "OK",
                1: "WARNING",
                2: "CRITICAL",
                3: "UNKNOWN",
                6: "PENDING"
            }
        }
        // Widget context
        _getOpenedNodes = function() {
            var res = [];
            this.node.find(".tree-wrapper tbody tr.opened").each(function() { res.push($(this).attr("data-url")); });
            return res;
        },
        _openNode = function(elem) {
            var url = decodeURIComponent(elem.attr("data-url")),
                level = parseInt(elem.attr("data-level")), elements,
                items = _dataSeparate(core.Data.get(url, true));
            if(elem.hasClass("opened")) { return; }
            for(var i = 0; i < items.length; i ++) {
                $.eachSort(items[i], "name", function(k, v) {
                    elem.after(factory_element(v, url + "/" + v.name, level + 1));
                });
            }
            elem.addClass("opened");
        },
        _dataSeparate = function(data) {
            var result = [{}, {}, {}, {}, {}];
            $.each(data || [], function(k, v) {
                if(v.type != "nagios") {
                    return result[0][k] = v;
                }
                if(v.rule == "host_group_up" || v.rule == "host_group_unfold") {
                    return result[1][k] = v;
                }
                if(v.rule == "service_group_unfold") {
                    return result[2][k] = v;
                }
                if(v.rule == "vhost_up" || v.rule == "host") {
                    return result[3][k] = v;
                }
                return result[4][k] = v;
            });
            return result;
        },
        factory_element = function(elem, path, l) {
            var allargs, hint = "bla";
            elem.result = elem.result || {};
            if (typeof(elem.result.status) === "undefined") {
                elem.result.status = 6;
                elem.status = "PENDING";
            }
            if ((elem.type === "nagios") && (/^host/.test(elem.rule))) {
                hint = statuses_hists["host"][elem.result.status];
            } else {
                hint = statuses_hists["service"][elem.result.status];
            }
            msg = elem.result.msg || "pending";
            last_check = $.timeFormat(parseInt(elem.result.last_check || 0) * 1000);
            last_state_change = $.timeDiffFormat(parseInt(elem.result.last_state_change) * 1000, core.Data.getServerTimestamp() * 1000);
            allargs = [];
            $.each(elem.args, function(k,v) {
                if(elem.rule == "service") {
                    allargs = allargs.concat(v.split("&"));
                } else {
                    allargs.push(v);
                }
            });
            allargs = allargs.length ? ("(" + allargs.join(", ") + ")") : "";
            var new_v = $($.tmpl(elem_temp, { 
                n: elem.name, 
                m: msg, 
                s: elem.status, 
                r: elem.rule,
                u: encodeURIComponent(path), 
                r: actions[elem.rule].name, 
                a: allargs,
                d: core.functions.ActionBuilder(elem, l === 0),
                l: l, 
                lc: last_check,
                h: hint,
                lstate: last_state_change 
            }));
            if(core.Data.hasItems(path)) {
                new_v.addClass("has-subitems");
            }
            $(".margin", new_v).width(l * 16);
            return new_v;
        };
    TreeView = function () {
        $($.recontext(this, this.init));
        $($.ns("core.events.DataWrapper")).bind("data-update", $.recontext(this, this.update_tree));
        $($.ns("core.events.NewNodeDialog")).bind("rule-add", {w: this}, function(e) { e.data.w.render(core.url.getAddr()); });
        $($.ns("core.events.NewNodeDialog")).bind("node-add", {w: this}, function(e) { e.data.w.render(core.url.getAddr()); });
        $($.ns("core.events.ContentLoader")).bind("load-page", {w: this}, function(e, p, m, is_internal) {
            if(m == "tree") {
                if(!is_internal) {
                    e.data.w.render(p);
                }
            } else {
                if(elements) {
                    elements.remove();
                    elements = false;
                    $("#display").css("padding-left", "340px");
                }
            }
        });
    };
    TreeView.prototype = {
        init: function() {
            this.node = $("#display");
            $("#view-port").on("submit", "#new-object-wrapper", {w: this}, function(e) {
                $(core.events.ModalWindow).triggerHandler("show", [$("#modal-windows #new-node-win"), true]);
            });
            this.node.on("click", ".expand-all", {w: this}, function(e) {
                e.data.w.show_all();
                $(".start-point", e.data.w.node).remove();
            });
            this.node.on("click", ".collapse-all", {w: this}, function(e) {
                core.url.setAddr("/", true);
            });
            this.node.on("click", ".has-subitems .arrow", function() {
                $(this).siblings(".name").trigger("click");
            });
            this.node.on("click", ".has-subitems .obj-name .name", {w: this}, function(e) {
                var pnode = $(this).parents("tr"),
                    url = decodeURIComponent(pnode.attr("data-url")),
                    level = parseInt(pnode.attr("data-level")), elements;
                pnode.parent().find(".current-element").removeClass("current-element");
                if(!pnode.hasClass("opened")) {
                    var items = _dataSeparate(core.Data.get(url, true));
                    for(var i = 0; i < items.length; i ++) {
                        $.eachSort(items[i], "name", function(k, v) {
                            pnode.after(factory_element(v, url + "/" + v.name, level + 1));
                        });    
                    }
                    pnode.addClass("opened");
                    core.url.setAddr(url);
                    pnode.addClass("current-element");
                } else {
                    pnode.removeClass("opened");
                    $("[data-url^=\""+encodeURIComponent(url + "/")+"\"]", e.data.w.node).remove();
                    var parts = url.split("/");
                    parts.pop();
                    var u = parts.join("/");
                    core.url.setAddr(u);
                    $("[data-url=\""+encodeURIComponent(u)+"\"]").addClass("current-element");
                }
                e.data.w.recolor();
            });
            this.node.on("click", ".action-button.edit", function() {
                var url = decodeURIComponent($(this).parents("tr").attr("data-url")), new_url;
                if (url[0] === "/") { url = url.slice(1); }
                var el = core.Data.get(url);
                (new_url = url.split("/")).pop(), new_url = new_url.join("/");
                core.url.setAddr(new_url);
                $(core.events.ModalWindow).triggerHandler("show", [$("#modal-windows #new-node-win"), url.split("/").length == 1]);
                $(core.events.NewNodeDialog).triggerHandler("show-dialog", [el.rule, el]);
            });

            this.node.on("click", ".action-button.add", function() {
                var url = decodeURIComponent($(this).parents("tr").attr("data-url"));
                if (url[0] === "/") { url = url.slice(1); }
                core.url.setAddr(url);
                $(core.events.ModalWindow).triggerHandler("show", [$("#modal-windows #new-node-win")]);
            });

            this.node.on("click", ".action-button.delete", {w: this}, function(e) {
                if(confirm("Are you sure want to delete?") == false) {
                    return;
                }
                var url = decodeURIComponent($(this).parents("tr").attr("data-url")), parts;
                if ((parts = url.split("/")).length === 1) {
                    core.Data.del_rule(url);
                    core.url.setAddr("/");
                } else {
                    core.Data.del(url);
                    core.url.setAddr(core.Data.getParentUrl(url));
                }
                e.data.w.render();
            });

            this.node.on("click", ".action-button.clone", {w: this}, function(e) {
                var widget = e.data.w, url = decodeURIComponent($(this).parents("tr").attr("data-url"));
                core.Data.clone_rule(url.split("/")[0], function(new_obj) {
                    core.url.setAddr(new_obj.name);
                    $(core.events.ModalWindow).triggerHandler("show", [$("#modal-windows #new-node-win"), true]);
                    $(core.events.NewNodeDialog).triggerHandler("show-dialog", [new_obj.rule, new_obj]);
                });
                widget.render();
            });
        },
        recolor: function() {
            var i = 0;
            $("tbody tr", this.node).removeClass("odd");
            $.each($("tbody tr", this.node), function(k, v) {
                $(v).addClass((k%2) ? "odd" : "even");
            });
        },
        update_tree: function(e, l, prefix) {
            l = l || 0;
            var opened = _getOpenedNodes.call(this), that = this;
            this.render(core.url.getCurrent(), true);
            $.each(opened, function(k, v) { _openNode.call(that, $("[data-url=\""+v+"\"]", that.node)); })
            this.recolor();
        },
        render_path: function(node, path, pre_path, l) {
            l = l || 0;
            pre_path = pre_path || "";
            var level_elements = core.Data.get(pre_path, true);
            var sd = _dataSeparate(level_elements);
            var allargs = [], last_check, last_state_change, msg, cur_path;
            for (var i = 0; i < sd.length; i++) {
                $.eachSort(sd[i], "name", function(k, v) {
                    node.after(factory_element(v, pre_path + (pre_path.length ? "/" : "") + v.name, l));
                });
            }
            path.replace(/^\/+/, "");
            if (!path) {
                return;
            }
            var p_parts = path.split("/");
            if (pre_path.length) {
                var rpa = pre_path.split("/");
                rpa.push(p_parts[0]);
                pre_path = rpa.join("/");
            }
            pre_path = pre_path.length ? pre_path : p_parts[0];
            p_parts.splice(0, 1);
            path = p_parts.join("/");
            var a = node.siblings("[data-url=\""+encodeURIComponent(pre_path)+"\"]").addClass("opened");
            this.render_path(a, path, pre_path, l + 1);
        },
        render: function(p, no_recolor) {
            p = p || core.url.getAddr();
            $("#display").css("padding-left", 0);
            elements = $(tmpl);
            this.node.empty();
            this.node.append(elements);
            this.render_path(elements.find(".start-point"), p);
            $(".start-point", this.node).remove();
            this.node.find("[data-url=\""+encodeURIComponent(p)+"\"]").addClass("current-element");
            if (!no_recolor) {
                this.recolor();
            }
            this.node.show();
        },
        show_all: function(node, p, l) {
            l = l || 0;
            p = p || "";
            if (!node) {
                this.node.find("tbody").empty().append("<tr class=\"start-point\"></tr>");
                node = this.node.find(".start-point");
            }
            var data = core.Data.get(p, true), cur_node, cur_path, that = this;
            var sd = _dataSeparate(data);
            for(var i = 0; i < sd.length; i++) {
                $.eachSort(sd[i], "name", function(k, v) {
                    node.after(cur_node = factory_element(v, cur_path = (p + (p.length ? "/" : "") + v.name), l));
                    if (core.Data.hasItems(cur_path)) {
                        cur_node.addClass("opened");
                        that.show_all(cur_node, cur_path, l + 1);
                    }
                });
            }
            this.recolor();
        }
    };
    $.ns("core.singeltons").TreeView = new TreeView;
})(_njq);

// Url builder
(function($) {
    var Url = function() {
        $(function() {
            $("#view-mode-switcher").bind("click", function() {
                core.url.setMode($(this).text(), true);
            });
        });
        $($.ns("core.events.ContentLoader")).bind("load-page", {w: this}, function(e) {
            e.data.w.cur_url = e.data.w.getAddr();
            $("#view-mode-switcher").text(core.url.getMode() == "tree" ? "flat" : "tree");
        });
    };
    Url.prototype = {
        setAddr: function(val, external) {
            if(val[0] == "/") {
                val = val.slice(1);
            }
            var parts = $.address.value().split(":"), url;
            parts[1] = encodeURIComponent(val);
            $.address.value(url = parts.join(":"));
            if(external) {
                core.changeFn.apply({}, [{path: url}, false]);
            }
        },
        getCurrent: function() {
            return this.cur_url;
        },
        getAddr: function() {
            return decodeURIComponent($.address.value().split(":")[1] || "/");
        },
        setMode: function(val, external) {
            var parts = $.address.value().split(":"), url;
            parts[0] = "/"+ val;
            $.address.value(url = parts.join(":"));
            if(external) {
                core.changeFn.apply({}, [{path: url}, false]);
            }
        },
        getMode: function() {
            return ($.address.value().split(":")[0] || "/tree").slice(1);
        }
    };
    core.url = new Url();
})(_njq);

// Init functions
(function($) {
    $(function() {
        core.base_url = $("#view-port").attr("data-base-url"); 
        core.base_url = core.base_url.substring(0, core.base_url.length - 1);
        core.mode = $("#view-port").attr("data-mode");
        core.auth_edit = parseInt($("#view-port").attr("data-auth-edit")) === 1;
        if (core.auth_edit === false) {
            $("#new-object-wrapper").remove();
            $("#facet>a").each(function() { $(this).css("left", $(this).offset().left - 110); });
        }
        var cls = core.classes.Scroll;
        s = new cls("#slider");
        $("#slider-go-left").bind("click", function() {
            $(core.events.Scroll).triggerHandler("move-left");
        });
        $("#slider-go-right").bind("click", function() {
            $(core.events.Scroll).triggerHandler("move-right");
        });
        cls = core.classes.BreadCrumbs;
        bc = new cls("#breadcrumbs");
        cls = core.classes.ContentLoader;
        cl = new cls("#nodes-wrapper");
        cls = core.classes.CurrentNode;
        cn = new cls("#current-node-top");
        if(core.mode == 2) {
            $("#nodes-new-element").hover(function(){ $(this).animate({opacity: 1}, 150); }, function() { $(this).animate({opacity: 0.5}, 150); });
        }
        cls = core.classes.NewElementList;
        (new cls("#new-node-win")); 
        cls = core.classes.DialogConfig;
        for(var name in actions) {
            if(!actions.hasOwnProperty(name)) continue;
            new cls(actions[name], name);
        }
        cls = core.classes.NewNodeDialog;
        new cls("#new-node-win");
        cls = core.classes.NodeFacet;
        new cls("#facet-form");
        cls = core.classes.LiveSearch;
        ls = new cls("#live-search");
        
    // Hints with tipsy (tooltips for jquery)
        $("#mode-swicher").tipsy();
        $("#quick-filter").tipsy({ title: 'hint', trigger: 'focus', gravity: 'e', offset: 5 });
        $("#icons>ul>li").filter(function() { return $(this).attr("onclick") === "window.location.reload()"; }).attr("onclick", null).bind("click", function() {
            core.Data.update();
        });
    });

    core.changeFn = function(e, type) {
        var addr = decodeURIComponent(e.path.substring(1)), def, parts = addr.split(":");
        if(parts.length === 1) {
            parts.unshift("tree");
            type = false;
            $.address.value("/tree:");
            return core.changeFn({path: "/tree:"}, false);
        }
        if(!parts[1].length && parts[0] != "tree") {
            for(var indx in core.Data.get(false, true)) {
                def = indx;
                break;
            }
            parts[1] = def;
            return $.address.value(parts.join(":")); 
        }
        if(parts[0] == "tree") {
            $("#slider-breadcrumbs").hide();
            $("#display").addClass("with_margin");
            $("#new-object-wrapper").show();
        } else {
            $("#display").show();
            $("#navigator").show();
            $("#slider-breadcrumbs").show();
            $("#display").removeClass("with_margin");
            $("#new-object-wrapper").hide();
        }
        $(core.events.ContentLoader).triggerHandler("load-page", [parts[1], parts[0], type]);
    };

    $.address.internalChange(function(e) { core.changeFn.apply(this, [e, true]); });
    $.address.externalChange(function(e) { core.changeFn.apply(this, [e, false]); });
})(_njq);
